diff --git a/pki/base/common/src/com/netscape/cmscore/security/JssSubsystem.java b/pki/base/common/src/com/netscape/cmscore/security/JssSubsystem.java
index d0df7d1a9514d15b4d105b55135d3ad0dfab0814..372b966bec400a585c1ce1066fca147152c2df94 100644
--- a/pki/base/common/src/com/netscape/cmscore/security/JssSubsystem.java
+++ b/pki/base/common/src/com/netscape/cmscore/security/JssSubsystem.java
@@ -128,8 +128,8 @@ public final class JssSubsystem implements ICryptoSubsystem {
     protected PasswordCallback mPWCB = null;
 
     private static JssSubsystem mInstance = new JssSubsystem();
-    private Hashtable mNicknameMapCertsTable = new Hashtable();
-    private Hashtable mNicknameMapUserCertsTable = new Hashtable();
+    private Hashtable<String, X509Certificate[]> mNicknameMapCertsTable = new Hashtable<String, X509Certificate[]>();
+    private Hashtable<String, X509Certificate[]> mNicknameMapUserCertsTable = new Hashtable<String, X509Certificate[]>();
 
 	private FileInputStream devRandomInputStream=null;
 
@@ -145,7 +145,7 @@ public final class JssSubsystem implements ICryptoSubsystem {
     private static final String PROP_SSL_CIPHERPREF = Constants.PR_CIPHER_PREF;
     private static final String PROP_SSL_ECTYPE = Constants.PR_ECTYPE;
 
-    private static Hashtable mCipherNames = new Hashtable();
+    private static Hashtable<String, Integer> mCipherNames = new Hashtable<String, Integer>();
 
     /* default sslv2 and sslv3 cipher suites(all), set if no prefs in config.*/
     private static final String DEFAULT_CIPHERPREF = 
@@ -518,12 +518,13 @@ public final class JssSubsystem implements ICryptoSubsystem {
 
     public String getTokenList() throws EBaseException {
         String tokenList = "";
-        Enumeration tokens = mCryptoManager.getExternalTokens();
+        @SuppressWarnings("unchecked")
+		Enumeration<CryptoToken> tokens = mCryptoManager.getExternalTokens();
         int num = 0;
 
         try {
             while (tokens.hasMoreElements()) {
-                CryptoToken c = (CryptoToken) tokens.nextElement();
+                CryptoToken c =  tokens.nextElement();
 
                 // skip builtin object token
                 if (c.getName() != null && c.getName().equals("Builtin Object Token")) {
@@ -607,10 +608,11 @@ public final class JssSubsystem implements ICryptoSubsystem {
         String certNames = "";
 
         try {
-            Enumeration enums = mCryptoManager.getAllTokens();
+            @SuppressWarnings("unchecked")
+			Enumeration<CryptoToken> enums = mCryptoManager.getAllTokens();
 
             while (enums.hasMoreElements()) {
-                CryptoToken token = (CryptoToken) enums.nextElement();
+                CryptoToken token = enums.nextElement();
                 CryptoStore store = token.getCryptoStore();
                 X509Certificate[] list = store.getCertificates();
 
@@ -1159,12 +1161,13 @@ CMS.debug("*** removing this interna cert");
     public NameValuePairs getRootCerts() throws EBaseException {
         NameValuePairs nvps = new NameValuePairs();
         try {
-            Enumeration enums = mCryptoManager.getAllTokens();
+            @SuppressWarnings("unchecked")
+			Enumeration<CryptoToken> enums = mCryptoManager.getAllTokens();
             if (mNicknameMapCertsTable != null)
                 mNicknameMapCertsTable.clear();
 
             // a temp hashtable with vectors
-            Hashtable vecTable = new Hashtable();
+            Hashtable<String, Vector<X509Certificate>> vecTable = new Hashtable<String, Vector<X509Certificate>>();
 
             while (enums.hasMoreElements()) {
                 CryptoToken token = (CryptoToken) enums.nextElement();
@@ -1187,11 +1190,11 @@ CMS.debug("*** removing this interna cert");
                         X509CertImpl impl = null;
 
                         try {
-                            Vector v;
+                            Vector<X509Certificate> v;
                             if (vecTable.containsKey((Object) nickname) == true) {
-                                v = (Vector) vecTable.get(nickname);
+                                v =  vecTable.get(nickname);
                             } else {
-                                v = new Vector();
+                                v = new Vector<X509Certificate>();
                             }
                             v.addElement(list[i]);
                             vecTable.put(nickname, v);
@@ -1212,11 +1215,11 @@ CMS.debug("*** removing this interna cert");
                     }
                 }   
                 // convert hashtable of vectors to hashtable of arrays
-                Enumeration elms = vecTable.keys();
+                Enumeration<String> elms = vecTable.keys();
 
                 while (elms.hasMoreElements()) {
                     String key = (String) elms.nextElement();
-                    Vector v = (Vector) vecTable.get((Object) key);
+                    Vector<X509Certificate> v =  vecTable.get((Object) key);
                     X509Certificate[] a = new X509Certificate[v.size()];
 
                     v.copyInto((Object[]) a);
@@ -1235,7 +1238,8 @@ CMS.debug("*** removing this interna cert");
     public NameValuePairs getUserCerts() throws EBaseException {
         NameValuePairs nvps = new NameValuePairs();
         try {
-            Enumeration enums = mCryptoManager.getAllTokens();
+            @SuppressWarnings("unchecked")
+			Enumeration<CryptoToken> enums = mCryptoManager.getAllTokens();
 
             while (enums.hasMoreElements()) {
                 CryptoToken token = (CryptoToken) enums.nextElement();
@@ -1301,7 +1305,8 @@ CMS.debug("*** removing this interna cert");
             mNicknameMapUserCertsTable.clear();
 
         try {
-            Enumeration enums = mCryptoManager.getAllTokens();
+            @SuppressWarnings("unchecked")
+			Enumeration<CryptoToken> enums = mCryptoManager.getAllTokens();
 
             while (enums.hasMoreElements()) {
                 CryptoToken token = (CryptoToken) enums.nextElement();
@@ -1382,36 +1387,36 @@ CMS.debug("*** removing this interna cert");
         }
 
             // a temp hashtable with vectors
-        Hashtable vecTable = new Hashtable();
+        Hashtable<String, Vector<X509Certificate>> vecTable = new Hashtable<String, Vector<X509Certificate>>();
 
         for (int i = 0; i < certs.length; i++) {
             String nickname = certs[i].getNickname();
 
             /* build a table of our own */
-            Vector v;
+            Vector<X509Certificate> v;
 
             if (vecTable.containsKey((Object) nickname) == true) {
-                v = (Vector) vecTable.get(nickname);
+                v =  vecTable.get(nickname);
             } else {
-                v = new Vector();
+                v = new Vector<X509Certificate>();
             }
             v.addElement(certs[i]);
             vecTable.put(nickname, v);
         }
 
         // convert hashtable of vectors to hashtable of arrays
-        Enumeration elms = vecTable.keys();
+        Enumeration<String> elms = vecTable.keys();
 
         while (elms.hasMoreElements()) {
             String key = (String) elms.nextElement();
-            Vector v = (Vector) vecTable.get((Object) key);
+            Vector<X509Certificate> v =  vecTable.get((Object) key);
             X509Certificate[] a = new X509Certificate[v.size()];
 
             v.copyInto((Object[]) a);
             mNicknameMapCertsTable.put(key, a);
         }
 
-        Enumeration keys = mNicknameMapCertsTable.keys(); 
+        Enumeration<String> keys = mNicknameMapCertsTable.keys(); 
 
         while (keys.hasMoreElements()) {
             String nickname = (String) keys.nextElement();
@@ -1719,9 +1724,6 @@ CMS.debug("*** removing this interna cert");
         } catch (IOException e) { 
             log(ILogger.LL_FAILURE, CMS.getLogMessage("CMSCORE_SECURITY_DELETE_CERT", e.toString()));
             throw new EBaseException(CMS.getUserMessage("CMS_BASE_CERT_ERROR", e.toString()));
-        } catch (CertificateException e) {
-            log(ILogger.LL_FAILURE, CMS.getLogMessage("CMSCORE_SECURITY_DELETE_CERT", e.toString()));
-            throw new EBaseException(CMS.getUserMessage("CMS_BASE_CERT_ERROR", e.toString()));
         }
     }
 
@@ -2121,7 +2123,7 @@ CMS.debug("*** removing this interna cert");
                 else {
                     try {
                         BasicConstraintsExtension ext = (BasicConstraintsExtension)
-                            exts.get(BasicConstraintsExtension.NAME);
+                            exts.get(BasicConstraintsExtension.class.getSimpleName());
 
                         if (ext == null)
                             return false;
diff --git a/pki/base/common/src/com/netscape/cmscore/security/KeyCertUtil.java b/pki/base/common/src/com/netscape/cmscore/security/KeyCertUtil.java
index 589d5a68c0fc70338e9c1ea5d599e70b056b100a..c020fe8bde29aed633b4659ab51d4ba7823c8021 100644
--- a/pki/base/common/src/com/netscape/cmscore/security/KeyCertUtil.java
+++ b/pki/base/common/src/com/netscape/cmscore/security/KeyCertUtil.java
@@ -158,7 +158,8 @@ public class KeyCertUtil {
     public static String getTokenNames(CryptoManager manager) 
         throws TokenException {
         String tokenList = "";
-        Enumeration tokens = manager.getExternalTokens();
+        @SuppressWarnings("unchecked")
+		Enumeration<CryptoToken> tokens = manager.getExternalTokens();
         int num = 0;
 
         while (tokens.hasMoreElements()) {
@@ -852,7 +853,7 @@ public class KeyCertUtil {
         BasicConstraintsExtension basic = new BasicConstraintsExtension(
                 bool, len);
 
-        ext.set(BasicConstraintsExtension.NAME, basic);
+        ext.set(BasicConstraintsExtension.class.getSimpleName(), basic);
     }
 
     public static void setExtendedKeyUsageExtension(
@@ -903,7 +904,7 @@ public class KeyCertUtil {
         }
 
         if (anyExt)
-            ext.set(ExtendedKeyUsageExtension.NAME, ns);
+            ext.set(ExtendedKeyUsageExtension.class.getSimpleName(), ns);
     }
 
     public static void setNetscapeCertificateExtension(
@@ -962,7 +963,7 @@ public class KeyCertUtil {
             anyExt = true;
         }
         if (anyExt)
-            ext.set(NSCertTypeExtension.NAME, ns);
+            ext.set(NSCertTypeExtension.class.getSimpleName(), ns);
     }
 
     public static void setOCSPNoCheck(KeyPair keypair, 
@@ -974,7 +975,7 @@ public class KeyCertUtil {
             OCSPNoCheckExtension noCheckExt = 
                 new OCSPNoCheckExtension();
 
-            ext.set(OCSPNoCheckExtension.NAME, noCheckExt);
+            ext.set(OCSPNoCheckExtension.class.getSimpleName(), noCheckExt);
         }
     }
 
@@ -984,13 +985,13 @@ public class KeyCertUtil {
         String signing = properties.getOCSPSigning();
 
         if ((signing != null) && (signing.equals(Constants.TRUE))) { 
-            Vector oidSet = new Vector(); 
+            Vector<ObjectIdentifier> oidSet = new Vector<ObjectIdentifier>(); 
             oidSet.addElement(
               ObjectIdentifier.getObjectIdentifier(
                 ExtendedKeyUsageExtension.OID_OCSPSigning));
             ExtendedKeyUsageExtension ocspExt = 
                 new ExtendedKeyUsageExtension(false, oidSet);
-            ext.set(ExtendedKeyUsageExtension.NAME, ocspExt);
+            ext.set(ExtendedKeyUsageExtension.class.getSimpleName(), ocspExt);
         }
     }
 
@@ -1009,7 +1010,7 @@ public class KeyCertUtil {
                 aiaExt.addAccessDescription(AuthInfoAccessExtension.METHOD_OCSP, ocspName);
             }
 
-            ext.set(AuthInfoAccessExtension.NAME, aiaExt);
+            ext.set(AuthInfoAccessExtension.class.getSimpleName(), aiaExt);
         }
     }
 
@@ -1023,7 +1024,7 @@ public class KeyCertUtil {
             AuthorityKeyIdentifierExtension akiExt = 
                 new AuthorityKeyIdentifierExtension(id, null, null);
 
-            ext.set(AuthorityKeyIdentifierExtension.NAME, akiExt);
+            ext.set(AuthorityKeyIdentifierExtension.class.getSimpleName(), akiExt);
         }
     }
 
@@ -1038,13 +1039,13 @@ public class KeyCertUtil {
             SubjectKeyIdentifierExtension skiExt =
                 new SubjectKeyIdentifierExtension(id.getIdentifier());
 
-            ext.set(SubjectKeyIdentifierExtension.NAME, skiExt);
+            ext.set(SubjectKeyIdentifierExtension.class.getSimpleName(), skiExt);
         }
     }
 
     public static void setKeyUsageExtension(CertificateExtensions ext,
         KeyUsageExtension keyUsage) throws IOException {
-        ext.set(KeyUsageExtension.NAME, keyUsage);
+        ext.set(KeyUsageExtension.class.getSimpleName(), keyUsage);
     }
 
     public static KeyIdentifier createKeyIdentifier(KeyPair keypair) 
diff --git a/pki/base/common/test/com/netscape/certsrv/app/CMSEngineDefaultStub.java b/pki/base/common/test/com/netscape/certsrv/app/CMSEngineDefaultStub.java
index ac5fe2247488885913f0713ea5f0133ed47b4077..c01ec33e8cff407dbb30a418319067daf825082b 100644
--- a/pki/base/common/test/com/netscape/certsrv/app/CMSEngineDefaultStub.java
+++ b/pki/base/common/test/com/netscape/certsrv/app/CMSEngineDefaultStub.java
@@ -126,11 +126,11 @@ public class CMSEngineDefaultStub implements ICMSEngine {
         return false;
     }
 
-    public Enumeration getSubsystemNames() {
+    public Enumeration <String> getSubsystemNames() {
         return null;
     }
 
-    public Enumeration getSubsystems() {
+    public Enumeration<ISubsystem> getSubsystems() {
         return null;
     }
 
@@ -459,17 +459,6 @@ public String getFingerPrints(byte[] certDer) throws NoSuchAlgorithmException {
         return null;
     }
 
-    public void getGeneralNameConfigDefaultParams(String name, boolean isValueConfigured, Vector params) {
-    }
-
-    public void getGeneralNamesConfigDefaultParams(String name, boolean isValueConfigured, Vector params) {
-    }
-
-    public void getGeneralNameConfigExtendedPluginInfo(String name, boolean isValueConfigured, Vector info) {
-    }
-
-    public void getGeneralNamesConfigExtendedPluginInfo(String name, boolean isValueConfigured, Vector info) {
-    }
 
     public IGeneralNamesConfig createGeneralNamesConfig(String name, IConfigStore config, boolean isValueConfigured, boolean isPolicyEnabled) throws EBaseException {
         return null;
@@ -483,11 +472,6 @@ public String getFingerPrints(byte[] certDer) throws NoSuchAlgorithmException {
         return null;
     }
 
-    public void getSubjAltNameConfigDefaultParams(String name, Vector params) {
-    }
-
-    public void getSubjAltNameConfigExtendedPluginInfo(String name, Vector params) {
-    }
 
     public ISubjAltNameConfig createSubjAltNameConfig(String name, IConfigStore config, boolean isValueConfigured) throws EBaseException {
         return null;
@@ -527,13 +511,6 @@ public String getFingerPrints(byte[] certDer) throws NoSuchAlgorithmException {
         return null;
     }
 
-    public IArgBlock createArgBlock(String realm, Hashtable httpReq) {
-        return null;
-    }
-
-    public IArgBlock createArgBlock(Hashtable httpReq) {
-        return null;
-    }
 
     public boolean isRevoked(X509Certificate[] certificates) {
         return false;
@@ -590,4 +567,59 @@ public String getFingerPrints(byte[] certDer) throws NoSuchAlgorithmException {
 		// TODO Auto-generated method stub
 		return null;
 	}
+
+	@Override
+	public void getGeneralNameConfigDefaultParams(String name,
+			boolean isValueConfigured, Vector<String> params) {
+		// TODO Auto-generated method stub
+		
+	}
+
+	@Override
+	public void getGeneralNamesConfigDefaultParams(String name,
+			boolean isValueConfigured, Vector<String> params) {
+		// TODO Auto-generated method stub
+		
+	}
+
+	@Override
+	public void getGeneralNameConfigExtendedPluginInfo(String name,
+			boolean isValueConfigured, Vector<String> info) {
+		// TODO Auto-generated method stub
+		
+	}
+
+	@Override
+	public void getGeneralNamesConfigExtendedPluginInfo(String name,
+			boolean isValueConfigured, Vector<String> info) {
+		// TODO Auto-generated method stub
+		
+	}
+
+	@Override
+	public void getSubjAltNameConfigDefaultParams(String name,
+			Vector<String> params) {
+		// TODO Auto-generated method stub
+		
+	}
+
+	@Override
+	public void getSubjAltNameConfigExtendedPluginInfo(String name,
+			Vector<String> params) {
+		// TODO Auto-generated method stub
+		
+	}
+
+	@Override
+	public IArgBlock createArgBlock(String realm,
+			Hashtable<String, String> httpReq) {
+		// TODO Auto-generated method stub
+		return null;
+	}
+
+	@Override
+	public IArgBlock createArgBlock(Hashtable<String, String> httpReq) {
+		// TODO Auto-generated method stub
+		return null;
+	}
 }
diff --git a/pki/base/common/test/com/netscape/cmscore/request/ExtDataHashtableTest.java b/pki/base/common/test/com/netscape/cmscore/request/ExtDataHashtableTest.java
index 7569ff20ad6afbf32f01232b61f9eb69dd151e50..c349b73d07c1f0c0f7e6d324434f3d2826bfcb47 100644
--- a/pki/base/common/test/com/netscape/cmscore/request/ExtDataHashtableTest.java
+++ b/pki/base/common/test/com/netscape/cmscore/request/ExtDataHashtableTest.java
@@ -9,14 +9,14 @@ import com.netscape.cmscore.test.CMSBaseTestCase;
 
 public class ExtDataHashtableTest extends CMSBaseTestCase {
 
-    ExtDataHashtable hash;
+    ExtDataHashtable<String> hash;
 
     public ExtDataHashtableTest(String name) {
         super(name);
     }
 
     public void cmsTestSetUp() {
-        hash = new ExtDataHashtable();
+        hash = new ExtDataHashtable<String>();
     }
 
     public void cmsTestTearDown() {
@@ -46,7 +46,7 @@ public class ExtDataHashtableTest extends CMSBaseTestCase {
     }
 
     public void testPutAll() {
-        Hashtable hash2 = new Hashtable();
+        Hashtable<String, String> hash2 = new Hashtable<String, String>();
         hash2.put("KEY1", "VAL1");
         hash2.put("KEY2", "val2");
 
@@ -67,11 +67,11 @@ public class ExtDataHashtableTest extends CMSBaseTestCase {
     }
 
     public void testMapConstructor() {
-        Hashtable hash2 = new Hashtable();
+        Hashtable<String, String> hash2 = new Hashtable<String, String>();
         hash2.put("KEY1", "VAL1");
         hash2.put("KEY2", "val2");
 
-        hash = new ExtDataHashtable(hash2);
+        hash = new ExtDataHashtable<String>(hash2);
 
         assertTrue(hash.containsKey("key1"));
         assertEquals("VAL1", hash.get("key1"));
diff --git a/pki/base/common/test/com/netscape/cmscore/request/RequestDefaultStub.java b/pki/base/common/test/com/netscape/cmscore/request/RequestDefaultStub.java
index f00eb8a748cf943d1398c05c65548dd2e248ab96..a835ba32c1d62819c407ef55354a3c33311b49b9 100644
--- a/pki/base/common/test/com/netscape/cmscore/request/RequestDefaultStub.java
+++ b/pki/base/common/test/com/netscape/cmscore/request/RequestDefaultStub.java
@@ -71,7 +71,7 @@ public class RequestDefaultStub implements IRequest {
         return null;
     }
 
-    public Enumeration getAttrNames() {
+    public Enumeration<String> getAttrNames() {
         return null;
     }
 
@@ -103,7 +103,7 @@ public class RequestDefaultStub implements IRequest {
         return false;
     }
 
-    public boolean setExtData(String key, Hashtable value) {
+    public boolean setExtData(String key, Hashtable<String, ?>  value) {
         return false;
     }
 
@@ -115,11 +115,11 @@ public class RequestDefaultStub implements IRequest {
         return null;
     }
 
-    public Hashtable getExtDataInHashtable(String key) {
+    public <V> Hashtable<String, V> getExtDataInHashtable(String key){
         return null;
     }
 
-    public Enumeration getExtDataKeys() {
+    public Enumeration<String> getExtDataKeys() {
         return null;
     }
 
@@ -223,11 +223,11 @@ public class RequestDefaultStub implements IRequest {
         return new RevokedCertImpl[0];
     }
 
-    public boolean setExtData(String key, Vector data) {
+    public boolean setExtData(String key, Vector<?> data) {
         return false;
     }
 
-    public Vector getExtDataInStringVector(String key) {
+    public Vector<String> getExtDataInStringVector(String key) {
         return null;
     }
 
diff --git a/pki/base/common/test/com/netscape/cmscore/request/RequestTest.java b/pki/base/common/test/com/netscape/cmscore/request/RequestTest.java
index 4000963183015942ee524d00791b8f24693b3c7b..dd1a16120d2e4006bfb51315dd6b9b9b015d321a 100644
--- a/pki/base/common/test/com/netscape/cmscore/request/RequestTest.java
+++ b/pki/base/common/test/com/netscape/cmscore/request/RequestTest.java
@@ -69,7 +69,7 @@ public class RequestTest extends CMSBaseTestCase {
 
     public void testIsSimpleExtDataValue() {
         request.mExtData.put("simple1", "foo");
-        request.mExtData.put("complex1", new Hashtable());
+        request.mExtData.put("complex1", new Hashtable<String, Object> ());
 
         assertTrue(request.isSimpleExtDataValue("simple1"));
         assertFalse(request.isSimpleExtDataValue("complex1"));
@@ -91,7 +91,8 @@ public class RequestTest extends CMSBaseTestCase {
         assertFalse(request.setExtData("key", (String)null));
     }
 
-    public void testVerifyValidExtDataHashtable() {
+    @SuppressWarnings({ "rawtypes", "unchecked" })
+	public void testVerifyValidExtDataHashtable() {
         Hashtable valueHash = new Hashtable();
 
         valueHash.put("key1", "val1");
@@ -103,8 +104,8 @@ public class RequestTest extends CMSBaseTestCase {
         assertFalse(request.isValidExtDataHashtableValue(valueHash));
 
         valueHash.clear();
-        valueHash.put(new Integer("0"), "bar");
-        assertFalse(request.isValidExtDataHashtableValue(valueHash));
+        //valueHash.put(new Integer("0"), "bar");
+        //assertFalse(request.isValidExtDataHashtableValue(valueHash));
 
         valueHash.clear();
         valueHash.put("okay", new Integer(5));
@@ -112,15 +113,16 @@ public class RequestTest extends CMSBaseTestCase {
 
     }
 
-    public void testSetExtHashtableData() {
-        Hashtable valueHash = new Hashtable();
+    @SuppressWarnings({ "unchecked", "rawtypes" })
+	public void testSetExtHashtableData() {
+        Hashtable<String, String> valueHash = new Hashtable<String, String>();
 
         valueHash.put("key1", "val1");
         valueHash.put("KEY2", "val2");
 
         request.setExtData("TOPKEY", valueHash);
 
-        Hashtable out = request.getExtDataInHashtable("topkey");
+        Hashtable<String, ?> out = request.getExtDataInHashtable("topkey");
         assertNotNull(out);
 
         assertTrue(out.containsKey("key1"));
@@ -137,7 +139,7 @@ public class RequestTest extends CMSBaseTestCase {
 
     public void testGetExtDataInString() {
         request.mExtData.put("strkey", "strval");
-        Hashtable hashValue = new Hashtable();
+        Hashtable<String, String> hashValue = new Hashtable<String, String>();
         hashValue.put("uh", "oh");
         request.mExtData.put("hashkey", hashValue);
 
@@ -150,11 +152,11 @@ public class RequestTest extends CMSBaseTestCase {
 
     public void testGetExtDataInHashtable() {
         request.mExtData.put("strkey", "strval");
-        Hashtable hashValue = new Hashtable();
+        Hashtable<String, String> hashValue = new Hashtable<String, String>();
         hashValue.put("uh", "oh");
         request.mExtData.put("hashkey", hashValue);
 
-        Hashtable out = request.getExtDataInHashtable("HASHKEY");
+        Hashtable<?, ?> out = request.getExtDataInHashtable("HASHKEY");
         assertNotNull(out);
         assertNull(request.getExtDataInHashtable("notfound"));
         assertNull(request.getExtDataInHashtable("strkey"));
@@ -171,7 +173,7 @@ public class RequestTest extends CMSBaseTestCase {
 
     public void testGetExtDataKeys() {
         request.setExtData("FOO", "val1");
-        request.setExtData("bar", new Hashtable());
+        request.setExtData("bar", new Hashtable<String, Object>());
 
         assertTrue(TestHelper.enumerationContains(request.getExtDataKeys(), "foo"));
         assertTrue(TestHelper.enumerationContains(request.getExtDataKeys(), "bar"));
@@ -181,14 +183,14 @@ public class RequestTest extends CMSBaseTestCase {
         // creates hashtable first time
         assertNull(request.getExtDataInHashtable("topkey"));
         request.setExtData("TOPKEY", "SUBKEY", "value");
-        Hashtable value = request.getExtDataInHashtable("topkey");
+        Hashtable<String, String> value = request.getExtDataInHashtable("topkey");
         assertNotNull(value);
         assertTrue(value.containsKey("subkey"));
         assertEquals("value", value.get("subkey"));
 
         // adds to existing hashtable
         assertNull(request.getExtDataInHashtable("topkey2"));
-        value = new Hashtable();
+        value = new Hashtable<String, String>();
         value.put("subkey2", "value2");
         request.setExtData("topkey2", value);
         request.setExtData("TOPKEY2", "subkey3", "value3");
@@ -219,7 +221,7 @@ public class RequestTest extends CMSBaseTestCase {
     }
 
     public void testGetExtDataSubkeyValue() {
-        Hashtable value = new Hashtable();
+        Hashtable<String, String> value = new Hashtable<String, String>();
         value.put("subkey", "value");
 
         request.setExtData("topkey", value);
@@ -259,7 +261,7 @@ public class RequestTest extends CMSBaseTestCase {
         assertEquals(data[2], retval[2]);
 
         // invalid conversion
-        Hashtable hashValue = new Hashtable();
+        Hashtable<String, String> hashValue = new Hashtable<String, String>();
         hashValue.put("0", "5");
         hashValue.put("1", "bar");
         request.setExtData("topkey2", hashValue);
@@ -298,7 +300,7 @@ public class RequestTest extends CMSBaseTestCase {
         assertEquals(data[2], retval[2]);
 
         // invalid conversion
-        Hashtable hashValue = new Hashtable();
+        Hashtable<String, String> hashValue = new Hashtable<String, String>();
         hashValue.put("0", "5");
         hashValue.put("1", "bar");
         request.setExtData("topkey2", hashValue);
@@ -357,7 +359,7 @@ public class RequestTest extends CMSBaseTestCase {
         };
 
         assertTrue(request.setExtData("key", vals));
-        Hashtable hashVals = (Hashtable)request.mExtData.get("key");
+        Hashtable<?, ?> hashVals = (Hashtable<?, ?>)request.mExtData.get("key");
         assertEquals(2, hashVals.keySet().size());
 
         assertFalse(cmsStub.aToBCalled);
@@ -376,7 +378,8 @@ public class RequestTest extends CMSBaseTestCase {
         assertTrue(request.setExtData("key", value));
 
         assertTrue(request.mExtData.containsKey("key"));
-        Hashtable hashValue = (Hashtable)request.mExtData.get("key");
+        @SuppressWarnings("unchecked")
+		Hashtable<String, String> hashValue = (Hashtable<String, String>)request.mExtData.get("key");
         assertTrue(hashValue.containsKey("0"));
         assertTrue(hashValue.containsKey("1"));
         assertTrue(hashValue.containsKey("2"));
@@ -394,7 +397,7 @@ public class RequestTest extends CMSBaseTestCase {
         assertEquals("orange", retval[3]);
 
         // Try with sparse input
-        hashValue = new Hashtable();
+        hashValue = new Hashtable<String, String>();
         hashValue.put("0", "square");
         hashValue.put("4", "triangle");
         hashValue.put("6", "octogon");
@@ -411,7 +414,7 @@ public class RequestTest extends CMSBaseTestCase {
         assertEquals("octogon", retval[6]);
 
         // invalid conversion
-        hashValue = new Hashtable();
+        hashValue = new Hashtable<String, String>();
         hashValue.put("0", "foo");
         hashValue.put("badkey", "bar");
         request.setExtData("cory", hashValue);
@@ -422,7 +425,7 @@ public class RequestTest extends CMSBaseTestCase {
     }
 
     public void testGetSetStringVector() {
-        Vector stringVector = new Vector();
+        Vector<String> stringVector = new Vector<String>();
         stringVector.add("blue");
         stringVector.add("green");
         stringVector.add("red");
@@ -431,7 +434,8 @@ public class RequestTest extends CMSBaseTestCase {
         assertTrue(request.setExtData("key", stringVector));
 
         assertTrue(request.mExtData.containsKey("key"));
-        Hashtable hashValue = (Hashtable)request.mExtData.get("key");
+        @SuppressWarnings("unchecked")
+		Hashtable<String, String> hashValue = (Hashtable<String, String>)request.mExtData.get("key");
         assertTrue(hashValue.containsKey("0"));
         assertTrue(hashValue.containsKey("1"));
         assertTrue(hashValue.containsKey("2"));
@@ -441,7 +445,7 @@ public class RequestTest extends CMSBaseTestCase {
         assertEquals("red", hashValue.get("2"));
         assertEquals("orange", hashValue.get("3"));
 
-        Vector retval = request.getExtDataInStringVector("key");
+        Vector<String> retval = request.getExtDataInStringVector("key");
         assertEquals(4, retval.size());
         assertEquals("blue", retval.elementAt(0));
         assertEquals("green", retval.elementAt(1));
@@ -449,13 +453,13 @@ public class RequestTest extends CMSBaseTestCase {
         assertEquals("orange", retval.elementAt(3));
 
         // invalid conversion
-        hashValue = new Hashtable();
+        hashValue = new Hashtable<String, String>();
         hashValue.put("0", "foo");
         hashValue.put("badkey", "bar");
         request.setExtData("cory", hashValue);
         assertNull(request.getExtDataInStringVector("cory"));
 
-        assertFalse(request.setExtData("key", (Vector)null));
+        assertFalse(request.setExtData("key", (Vector<?>)null));
     }
 
     public void testGetSetCertInfo() {
@@ -482,7 +486,7 @@ public class RequestTest extends CMSBaseTestCase {
         };
 
         assertTrue(request.setExtData("key", vals));
-        Hashtable hashVals = (Hashtable)request.mExtData.get("key");
+        Hashtable<?, ?> hashVals = (Hashtable<?, ?>)request.mExtData.get("key");
         assertEquals(2, hashVals.keySet().size());
 
         assertFalse(cmsStub.aToBCalled);
@@ -493,7 +497,7 @@ public class RequestTest extends CMSBaseTestCase {
     }
 
     public void testGetBoolean() {
-        Hashtable hashValue = new Hashtable();
+        Hashtable<String, String> hashValue = new Hashtable<String, String>();
         hashValue.put("one", "false");
         hashValue.put("two", "true");
         hashValue.put("three", "on");
@@ -532,7 +536,7 @@ public class RequestTest extends CMSBaseTestCase {
         };
 
         assertTrue(request.setExtData("key", vals));
-        Hashtable hashVals = (Hashtable)request.mExtData.get("key");
+        Hashtable<?, ?> hashVals = (Hashtable<?, ?>)request.mExtData.get("key");
         assertEquals(2, hashVals.keySet().size());
 
         assertFalse(cmsStub.aToBCalled);
